% Cross flow mixed
%global Tsw Do g hi Di k dl ro u cp lambda l data ks mtot textdata xtubes mod Pinn teta hikonst hokonst Tstart Rf
global Do Di k ks vsw mtot Tstart Pinn data l mod textdata xtubes waterorient msw Tsw s hikonst hokonst cpsw Rf g dl

for i=1:length(textdata)
    if strcmp(textdata(i),'Enth (kJ/kg)')==1
        entrow=i;
    elseif strcmp(textdata(i),'Gas molfrac (mol%)')==1
        molfracrow=i;
    elseif strcmp(textdata(i),'Gas massfrac (mass%)')==1
        massfracrow=i;
    elseif strcmp(textdata(i),'Total density (kg/m3)')==1
        totdensrow=i;
    elseif strcmp(textdata(i),'Gas density (kg/m3)')==1
        gasdensrow=i;
    elseif strcmp(textdata(i),'Liquid density (kg/m3)')==1
        liqdensrow=i;
    elseif strcmp(textdata(i),'Gas viscosity (cP)')==1
        gasviscrow=i;
    elseif strcmp(textdata(i), 'Liquid viscosity (cP)')==1
        liqviscrow=i;
    elseif strcmp(textdata(i), 'Gas CP (kj/kgK)')==1
        gascprow=i;
    elseif strcmp(textdata(i), 'Liquid CP (kj/kgK)')==1
        liqcprow=i;
    elseif strcmp(textdata(i), 'Gas thermal conduc (mW/mC)')==1
        gascondrow=i;
    elseif strcmp(textdata(i), 'Liquid thermal conduc (mW/mC)')==1
        liqcondrow=i;
    elseif strcmp(textdata(i), 'Oil/gas interfacial tension (mN/m)')==1
        surftensrow=i;
    end
end


g=9.81;  
  
n=round(l/dl);  
dA=pi*Do*l/n;   
T=zeros(xtubes,n);
Tw=zeros(xtubes,n);

Twater=zeros(1, xtubes);
Twater(1)=Tsw;

m=zeros(1,xtubes);
dampfrac=zeros(1,xtubes);
P=T;
htottab=T;
hitab=T;
hwtab=T;
hiwtab=T;
hutside=T;
friksjon=T;
Reynold=T;
x=T;
Prandtl=T;
trykktap=m;
dp=0;
dm=0;

for ror=1:xtubes
    m(ror)=mtot/xtubes;   
end

[dpmin,jmin]=min(trykktap);
[dpmax, jmax]=max(trykktap);
deltadp=dpmax-dpmin;
while (deltadp>100) || (trykktap(1)==0)
    if (trykktap(1))~=0
        dm=(deltadp/2)^(1/2)*Di^2/l;
        m(jmax)=m(jmax)-dm;
        m(jmin)=m(jmin)+dm;
    end
    Qtot=0;
    for j=1:xtubes
        G=m(j)*4/(pi*Di^2); 
        
        T(j,1)=Tstart;
        ro=interp1(data(1,:),data(gasdensrow,:), T(j,1),'spline'); 
        u=(interp1(data(1,:),data(gasviscrow,:), T(j,1),'spline'))/1000; 
        cp=(interp1(data(1,:),data(gascprow,:), T(j,1),'spline'))*1000; 
        lambda=(interp1(data(1,:),data(gascondrow,:), T(j,1),'spline'))/1000; 
        ul=(interp1(data(1,:), data(liqviscrow,:), T(j,1), 'spline'))/1000; 
        rol=interp1(data(1,:), data(liqdensrow,:), T(j,1),'spline'); 
        lambdal=(interp1(data(1,:),data(liqcondrow,:), T(j,1),'spline'))/1000; 
        cpl=(interp1(data(1,:),data(liqcprow,:), T(j,1),'spline'))*1000 ;  
        sigma=(interp1(data(1,:), data(surftensrow,:), T(j,1), 'spline'))/1000; 
        Pr=u*cp/lambda;
        Prl=ul*cpl/lambdal;
   
        
        molfrac=(interp1(data(1,:),data(molfracrow,:), T(j,1)))/100;
        massfraci=(interp1(data(1,:),data(massfracrow,:), T(j,1)))/100;
        
        if isnan(massfraci)==1
            massfraci=1;
        elseif massfraci>0.99 && massfraci<1
            massfraci=.99;
        end
        
        
        
        if massfraci==1
            v=m(j)/(ro*(pi*Di^2/4));
            Re=ro*v*Di/u;
            
            f=trykkfall(Re, ks, Di);
            if mod~=4
                hi=hindre(Re, Pr, Di, l, lambda,f);
            elseif mod==4
                hi=hikonst;
            end
        elseif (massfraci<=1) && (massfraci>=0)
            entalp1=(interp1(data(1,:),data(entrow,:), (T(j,1)+.5),'spline'))*1000;
            entalp2=(interp1(data(1,:),data(entrow,:), T(j,1),'spline'))*1000;  
            dtdh=((T(j,1)+.5)-Tstart)/(entalp1-entalp2);
            zg=massfraci*cp*dtdh;        
            
            
            mliq=abs(m(j)*(1-massfraci));    
            

            e1=lmevoid(massfraci,ro,rol,G,sigma);
            delta=Di/2- (e1*Di^2)^(1/2)/2; 
            
            Prl=ul*cpl/lambdal;
            Rel=4*G*(1-massfraci)*delta/((1-e1)*ul); 
            Relo=G*Di/ul;
            Rego=G*Di/u;
            
            vgs=G*massfraci/ro;
            Regs=ro*vgs*Di/u;
            vg=G*massfraci/(ro*e1);
            Re=ro*vg*Di/u;
            vl=G*(1-massfraci)/(rol*(1-e1)); 
            fgs=trykkfall(Regs, ks, Di);
            dpfdl=fuchscorrected(massfraci, G, Relo, Rego, rol, ro);   
            if mod~=4
                if mod==2
                    
                    hliq=hliquidboy(massfraci, Relo, lambdal, Prl, rol, ro);
                    
                    dpfgsdl=trykkfall(Regs, ks, Di)*ro*vgs^2/(2*Di); 
                    cf=(dpfdl/dpfgsdl)^0.445;
                    
                    hg=cf*hindreglatt(Re, Pr, lambda, Di);
                    
                elseif mod==1
                    
                    taui=dpfdl*Di/4;
                    hliq= hliquid(Rel, rol, ul, lambdal, cpl, taui);    
                    dpfgsdl=trykkfall(Regs, ks, Di)*ro*vgs^2/(2*Di); 
                    cf=(dpfdl/dpfgsdl)^0.445;
                    hg=cf*hindreglatt(Re, Pr,lambda,Di);
                else
                    fi=1+ (vg/vl)^(0.5)*((rol-ro)*g*delta^2/sigma)^(1/4);   
                    hliq=0.003*Rel^0.74*Prl^0.5*lambdal*fi/delta;
                    hg=fi*hindreglatt(Re, Pr, lambda, Di);
                end
                
                hi=1/((1/hliq)+(zg/hg));
            elseif mod==4
                hi=hikonst;
            end
        elseif massfraci==0
              v=m(j)/(rol*(pi*Di^2/4));
            Rel=rol*v*Di/ul;
            
            f=trykkfall(Rel, ks, Di);
            if mod~=4
                hi=hindre(Rel, Prl, Di, l, lambdal,f);
            elseif mod==4
                hi=hikonst;
            end
            
        end

        
        P(j,1)=Pinn;
        
        
        Q=0;
        dpftp=0;
        dpfsp=0;
        dpa=0;
        dph=0;
        dphdl=0;
        x(1)=0;
        
        Tw(j,1)=twallstart(T(j,1), hi, vsw,teta, (x(1)+dl), Twater(j),waterorient); 
        dp=0;
        for i=1:(n)
            
            x(i+1)=x(i)+dl;
            
            if hokonst==0
                ho=hytrekomb(Tw(j,i), vsw, teta, x(i+1), Twater(j),waterorient); 
            else
                ho=hokonst;
            end
            hutside(j,i)=ho;
           
            ro=interp1(data(1,:),data(gasdensrow,:), T(j,i),'spline'); 
            u=(interp1(data(1,:),data(gasviscrow,:), T(j,i),'spline'))/1000; 
            cp=(interp1(data(1,:),data(gascprow,:), T(j,i),'spline'))*1000; 
            lambda=(interp1(data(1,:),data(gascondrow,:), T(j,i),'spline'))/1000; 
            
            ul=(interp1(data(1,:), data(liqviscrow,:), T(j,i), 'spline'))/1000; 
            rol=interp1(data(1,:), data(liqdensrow,:), T(j,i),'spline'); 
            lambdal=(interp1(data(1,:),data(liqcondrow,:), T(j,i),'spline'))/1000; 
            cpl=(interp1(data(1,:),data(liqcprow,:), T(j,i),'spline'))*1000 ;  
            sigma=(interp1(data(1,:), data(surftensrow,:), T(j,i), 'spline'))/1000; 
            
            Pr= u*cp/lambda;
            Prl=ul*cpl/lambdal;
            massfrac=(interp1(data(1,:),data(massfracrow,:), T(j,i)))/100;
            
            if isnan(massfrac)==1
                massfrac=1;
%             elseif massfrac>0.99 && massfrac<1
%                 massfrac=.99;
            end
            
         
            hwtab(j,i)=2*k/(Do*log(Do/Di));
            
            if massfrac==1  
                
                v=m(j)/(ro*(pi*Di^2/4));
                Re=ro*v*Di/u;
                Pr= u*cp/lambda;
                
                f=trykkfall(Re, ks, Di);
                if mod~=4
                    hi=hindre(Re, Pr, Di, l, lambda,f);
                elseif mod==4
                    hi=hikonst;
                end
                h= 1/((1/ho)+Rf+(Do/(hi*Di))+(log(Do/Di)*Do/(2*k))); 
                hiw=1/((Do/(hi*Di))+Rf+(log(Do/Di)*Do/(2*k)));   
                
                T(j,i+1)=T(j,i)+ dA*h*(Twater(j)-T(j,i))/(m(j)*cp);
                Tw(j,i+1)=T(j,i) - (h/hiw)*(T(j,i)-Twater(j)); 
                dQ=m(j)*cp*(T(j,i)-T(j,i+1));
                
                dpfdl= f*v^2*ro/(2*Di); 
                ro2=interp1(data(1,:),data(gasdensrow,:), T(j,i+1),'spline');
                dpadl=-G^2*((1/ro2)-(1/ro)); 
                if teta==90
                    dphdl=(ro+ro2)*g/2;
                    dph=dph+ dphdl*dl;
                end
                dpa=dpa+dpadl;
                dpfsp=dpfsp+dpfdl*dl;
                P(j,i+1)=P(j,i)-dpfdl*dl/1e5 + dpadl/1e5-dphdl*dl/1e5;
                hitab(j,i)=hi*Di/Do;
                hiwtab(j,i)=hiw;
                htottab(j,i)=h;
            elseif massfrac<1 && massfrac>0 
                entalp1=(interp1(data(1,:),data(entrow,:), T(j,i),'spline'))*1000;
                if i>1
                    
                    entalp2=(interp1(data(1,:),data(entrow,:), T(j,i-1),'spline'))*1000;  
                    dtdh=(T(j,i)-T(j,i-1))/(entalp1-entalp2);
                    zg=massfrac*cp*dtdh;       
                end

                mliq=abs(m(j)*(1-massfrac));   
    
                e1=lmevoid(massfrac,ro,rol,G,sigma);
                delta=Di/2- (e1*Di^2)^(1/2)/2; 
                
                vg=G*massfrac/(ro*e1); 
                vl=G*(1-massfrac)/(rol*(1-e1)); 
                
                vgs=G*massfrac/ro;  
                
                
                Re=ro*vg*Di/u; 
                Rel=4*G*(1-massfrac)*delta/(ul*(1-e1)); 
                Relo=G*Di/ul;
                Rego=G*Di/u;
                Regs=ro*vgs*Di/u;
                
                dpfdl=fuchscorrected(massfrac, G, Relo, Rego, rol, ro);   
                fgs=trykkfall(Regs, ks, Di);
                
                if mod~=4
                    if massfrac<0.95
                    if mod==1
                        dpfgsdl=trykkfall(Regs, ks, Di)*ro*vgs^2/(2*Di); 
                        cf=(dpfdl/dpfgsdl)^0.445;
                       
                        taui=dpfdl*Di/4;
                        hliq= hliquid(Rel, rol, ul, lambdal, cpl, taui);   
                        hg=cf*hindreglatt(Re, Pr, lambda,Di);
                    elseif mod==2
                        hliq=hliquidboy(massfrac, Relo, lambdal, Prl, rol, ro);  
                        
                        dpfgsdl=fgs*ro*vgs^2/(2*Di);
                        cf=(dpfdl/dpfgsdl)^0.445;
                        hg=cf*hindreglatt(Re, Pr, lambda, Di);
                        
                    elseif mod==3
                        fi=1+ (vg/vl)^(0.5)*((rol-ro)*g*delta^2/sigma)^(1/4);   
                        hliq=0.003*Rel^0.74*Prl^0.5*lambdal*fi/delta;
                        hg=fi*hindreglatt(Re, Pr, lambda, Di);
                    end
                
                    heff=1/((1/hliq)+(zg/hg)); 
                    elseif massfrac>0.95
                        heff=hindre(Regs,Pr,Di,l,lambda,fgs);
                    end
                elseif mod==4
                    heff=hikonst;
                end
                h= 1/((1/ho)+Rf+(Do/(heff*Di))+(log(Do/Di)*Do/(2*k)));  
                dQ=h*dA*(T(j,i)-Twater(j));
                
                entalp=entalp1*m(j)-dQ;  
                
                hiw=1/((Do/(heff*Di))+Rf+(log(Do/Di)*Do/(2*k)));
                
                T(j,i+1)=interp1(data(entrow,:), data(1,:), entalp/(m(j)*1000),'spline');
                Tw(j,i+1)=T(j,i) - (h/hiw)*(T(j,i)-Twater(j));
                
                ro2=interp1(data(1,:),data(gasdensrow,:), T(j,i+1),'spline');
                rol2=interp1(data(1,:), data(liqdensrow,:), T(j,i+1),'spline'); 
                massfrac2=(interp1(data(1,:),data(massfracrow,:), T(j,i+1)))/100;
                
                e2=lmevoid(massfrac2,ro2,rol2,G,sigma);
                
                if teta==90
                    dphdl=((ro+ro2)*(e1+e2)/4 + ((rol+rol2)/2)*(1 - (e1+e2)/2))*g;
                    dph=dph+ dphdl*dl;
                end
                
                dpadl=-G^2*((massfrac2^2/(e2*ro2))+ ((1-massfrac2)^2/((1-e2)*rol2)) - ((massfrac^2/(e1*ro))+ ((1-massfrac)^2/((1-e1)*rol))));
                dpa=dpa+dpadl; 
                

                dpftp=dpftp+dpfdl*dl;
                
                hitab(j,i)=heff*Di/Do;
               
                htottab(j,i)=h;
                P(j,i+1)=P(j,i)-dpfdl*dl/1e5+dpadl/1e5-dphdl*dl/1e5; 
            elseif massfrac==0    
                v=m(j)/(rol*(pi*Di^2/4));
                Re=rol*v*Di/ul;
                
                f=trykkfall(Rel, ks, Di);
                if mod~=4
                    hi=hindre(Rel, Pr, Di, l, lambdal,f);
                elseif mod==4
                    hi=hikonst;
                end
                h= 1/((1/ho)+(Do/(hi*Di))+(log(Do/Di)*Do/(2*k)));
                hiw=1/((Do/(hi*Di))+(log(Do/Di)*Do/(2*k))); 

                T(j,i+1)=T(j,i)+ dA*h*(Twater(j)-T(j,i))/(m(j)*cpl); 
                Tw(j,i+1)=T(j,i) - (h/hiw)*(T(j,i)-Twater(j)); 
                dQ=m(j)*cpl*(T(j,i)-T(j,i+1));
                
                dpfdl= f*v^2*rol/(2*Di);
                ro2l=interp1(data(1,:),data(liqdensrow,:), T(j,i+1),'spline');
                dpadl=-G^2*((1/ro2l)-(1/rol)); 
                dpa=dpa+dpadl;
                dpfsp=dpfsp+dpfdl*dl;
                P(j,i+1)=P(j,i)-dpfdl*dl/1e5 - dpadl/1e5;
                hitab(j,i)=hi;
                hiwtab(j,i)=hiw;
                htottab(j,i)=h;
            end

            dp=dp+dpfdl*dl-dpadl+dphdl*dl;

            Q=Q+dQ;

        end
        trykktap(j)=dp; 
        dampfrac(j)=massfrac;
        if j<xtubes
            Twater(j+1)=Q/(msw*cpsw) + Twater(j);
   
        end
        Qtot=Qtot+Q;
    end
    trykktap;
    [dpmin,jmin]=min(trykktap);
    [dpmax, jmax]=max(trykktap);
    deltadp=dpmax-dpmin;
end

deltaH=interp1(data(1,:),data(entrow,:),Tstart)*mtot*1000-Qtot;

Tout=interp1(data(entrow,:), data(1,:),deltaH/(mtot*1000));
massfracout=interp1(data(1,:),data(massfracrow,:), Tout)/100;
deltaP=mean(trykktap)/1e5;
output.Duty_kW=Qtot/1e3;
output.T_out=Tout;
output.Pressure_loss_Bar=deltaP;
output.Outer_Area_m2=pi*Do*l*xtubes;
output.Mass_fraction=massfracout;

disp(output)
x=0:dl:l;
figure(1)
ji=plot(x,T(1,:),x, Tw(1,:));
grid on
xlabel('z [m]')
ylabel('T [C]')
legend('Tube', 'Wall');
set(ji,'LineWidth',2.5)

figure(2)
x2=0:dl:(l-dl);
gi=plot(x2, hitab(1,:), x2, hutside(1,:), x2, htottab(1,:));
grid on
xlabel('z [m]')
ylabel(' HTC [W/m2K]')
legend('Tubeside HTC', 'Waterside HTC', 'Overall HTC');
set(gi,'LineWidth',2.5)

