% Frictional pressure gradient from corrected Fuchs
function dpdz=fuchscorrected(x,G,Relo,Rego,rol,rog)
dpfuchs=fuchs(x,G,Relo,Rego,rol,rog);
densrat=rol/rog;
if densrat>20
    g=1.0/0.3;
elseif (densrat>=6.5) && (densrat < 20)
    g=densrat^(0.4);
else
    g=6.5^(0.4);
end
if x <= 0.725
    h=(sin(pi*x)+sin(pi*x^3))/1.69;
else
    h=1.0-sin((pi/2)*((x-0.725)/0.275)^(5*x^(7/2)));
end
corr=1.0-(1.0-0.3*g)*h;
dpdz=dpfuchs*corr;