
clear all
global Do Di k ks vsw mtot Tstart Pinn data l mod textdata xtubes waterorient msw Tsw s hikonst hokonst cpsw Rf
s = warning('off', 'all');
%Tube spesifications
Do=0.0603;
veggtykkelse=0.00391;
Di=Do- 2*veggtykkelse;
l=220;
k=15; %Tube thermal conductivity
ks=0.002e-3; %Tube wall roughness 
%ks=50e-6;
xtubes=1;   %NUmber of tubes
teta=0;
%Inlet conditions
Tstart=80;
mtot=1;    %total mass flow
Pinn=100; %inlet pressure

%Step size
dl=0.04;
%Waterside flow
% 1 for natural convection, 2 for cross flow mixed,3 for cross flow unmixed, 4 for cocurrrent, 5 for
% countercurrent 
waterorient=1;
Tsw=5;

%Fouling resistance
Rf=0;

Atot=Do*pi*l*xtubes;
rosw=1000;
cpsw=4200;
if waterorient==1
    vsw=0;
elseif waterorient==2 || waterorient==3
    msw=Inf;    
    vsw=0.6;
elseif waterorient==4 || waterorient==5
    msw=Inf;   
    vsw=1;
end    
%file with properties
importfile('gas100.csv')
data;
textdata;
%Correlation for HTC in condesing: 1 for HEDH, 2 for Boyko &
%Kruzshuilin, 3 for thome 4 for konst
mod=2;

if mod==4
    hikonst=1000; %Constant tube-side HTC
end

%Hokonst equal to zero if not used. if desirable with constant outer HTC
%set hokonst to desired value
hokonst=0;

if waterorient==1
    euler1naturlig
elseif waterorient==2
    euler1crossmixed
elseif waterorient==3
    euler1crossunmixed
elseif waterorient==4
    euler1cocurrent
elseif waterorient==5
    euler1countercurrent
end
